Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.ibatis
Class SqlMapClientFactoryBean

    java.lang.Object
      org.springframework.orm.ibatis.SqlMapClientFactoryBean

All Implemented Interfaces:
  FactoryBean<com.ibatis.sqlmap.client.SqlMapClient>, InitializingBean

    public class SqlMapClientFactoryBean

extends java.lang.Object
implements FactoryBean<com.ibatis.sqlmap.client.SqlMapClient>, InitializingBean

`FactoryBean` that creates an iBATIS `SqlMapClient`. This is the usual way to set up a shared iBATIS SqlMapClient in a Spring application context; the SqlMapClient can then be passed to iBATIS-based DAOs via dependency injection.

Either `DataSourceTransactionManager` or `JtaTransactionManager` can be used for transaction demarcation in combination with a SqlMapClient, with JTA only necessary for transactions which span multiple databases.

Allows for specifying a DataSource at the SqlMapClient level. This is preferable to per-DAO DataSource references, as it allows for lazy loading and avoids repeated DataSource references in every DAO.

Note: As of Spring 2.5.5, this class (finally) requires iBATIS 2.3 or higher. The new "mappingLocations" feature requires iBATIS 2.3.2.

Since:
  24.02.2004
Author:
  Juergen Hoeller
See Also:
  `setConfigLocation(org.springframework.core.io.Resource)`, `setDataSource(javax.sql.DataSource)`, `SqlMapClientTemplate.setSqlMapClient(com.ibatis.sqlmap.client.SqlMapClient)`, `JdbcAccessor.setDataSource(javax.sql.DataSource)`

Constructor Summary
`SqlMapClientFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`protected void` | `applyTransactionConfig(com.ibatis.sqlmap.client.SqlMapClient sqlMapClient, com.ibatis.sqlmap.engine.transaction.TransactionConfig transactionConfig)` Apply the given iBATIS TransactionConfig to the SqlMapClient.
`protected com.ibatis.sqlmap.client.SqlMapClient` | `buildSqlMapClient(Resource[] configLocations, Resource[] mappingLocations, java.util.Properties properties)` Build a SqlMapClient instance based on the given standard configuration.
`static LobHandler` | `getConfigTimeLobHandler()` Return the LobHandler for the currently configured iBATIS SqlMapClient, to be used by TypeHandler implementations like ClobStringTypeHandler.
`com.ibatis.sqlmap.client.SqlMapClient` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<? extends com.ibatis.sqlmap.client.SqlMapClient>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setConfigLocation(Resource configLocation)` Set the location of the iBATIS SqlMapClient config file.
`void` | `setConfigLocations(Resource[] configLocations)` Set multiple locations of iBATIS SqlMapClient config files that are going to be merged into one unified configuration at runtime.
`void` | `setDataSource(javax.sql.DataSource dataSource)` Set the DataSource to be used by iBATIS SQL Maps.
`void` | `setLobHandler(LobHandler lobHandler)` Set the LobHandler to be used by the SqlMapClient.
`void` | `setMappingLocations(Resource[] mappingLocations)` Set locations of iBATIS sql-map mapping files that are going to be merged into the SqlMapClient configuration at runtime.
`void` | `setSqlMapClientProperties(java.util.Properties sqlMapClientProperties)` Set optional properties to be passed into the SqlMapClientBuilder, as alternative to a `<properties>` tag in the sql-map-config.xml file.
`void` | `setTransactionConfigClass(java.lang.Class transactionConfigClass)` Set the iBATIS TransactionConfig class to use.
`void` | `setTransactionConfigProperties(java.util.Properties transactionConfigProperties)` Set properties to be passed to the TransactionConfig instance used by this SqlMapClient.
`void` | `setUseTransactionAwareDataSource(boolean useTransactionAwareDataSource)` Set whether to use a transaction-aware DataSource for the SqlMapClient, i.e.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SqlMapClientFactoryBean

    public SqlMapClientFactoryBean()

Method Detail

### getConfigTimeLobHandler

    public static LobHandler getConfigTimeLobHandler()

  Return the LobHandler for the currently configured iBATIS SqlMapClient, to be used by TypeHandler implementations like ClobStringTypeHandler.

  This instance will be set before initialization of the corresponding SqlMapClient, and reset immediately afterwards. It is thus only available during configuration.

  See Also:
    `setLobHandler(org.springframework.jdbc.support.lob.LobHandler)`, `ClobStringTypeHandler`, `BlobByteArrayTypeHandler`, `BlobSerializableTypeHandler`

### setConfigLocation

    public void setConfigLocation(Resource configLocation)

  Set the location of the iBATIS SqlMapClient config file. A typical value is "WEB-INF/sql-map-config.xml".

  See Also:
    `setConfigLocations(org.springframework.core.io.Resource[])`

### setConfigLocations

    public void setConfigLocations(Resource[] configLocations)

  Set multiple locations of iBATIS SqlMapClient config files that are going to be merged into one unified configuration at runtime.

### setMappingLocations

    public void setMappingLocations(Resource[] mappingLocations)

  Set locations of iBATIS sql-map mapping files that are going to be merged into the SqlMapClient configuration at runtime.

  This is an alternative to specifying "<sqlMap>" entries in a sql-map-client config file. This property being based on Spring's resource abstraction also allows for specifying resource patterns here: e.g. "/myApp/*-map.xml".

  Note that this feature requires iBATIS 2.3.2; it will not work with any previous iBATIS version.

### setSqlMapClientProperties

    public void setSqlMapClientProperties(java.util.Properties sqlMapClientProperties)

  Set optional properties to be passed into the SqlMapClientBuilder, as alternative to a `<properties>` tag in the sql-map-config.xml file. Will be used to resolve placeholders in the config file.

  See Also:
    `setConfigLocation(org.springframework.core.io.Resource)`, `SqlMapClientBuilder.buildSqlMapClient(java.io.InputStream, java.util.Properties)`

### setDataSource

    public void setDataSource(javax.sql.DataSource dataSource)

  Set the DataSource to be used by iBATIS SQL Maps. This will be passed to the SqlMapClient as part of a TransactionConfig instance.

  If specified, this will override corresponding settings in the SqlMapClient properties. Usually, you will specify DataSource and transaction configuration either here or in SqlMapClient properties.

  Specifying a DataSource for the SqlMapClient rather than for each individual DAO allows for lazy loading, for example when using PaginatedList results.

  With a DataSource passed in here, you don't need to specify one for each DAO. Passing the SqlMapClient to the DAOs is enough, as it already carries a DataSource. Thus, it's recommended to specify the DataSource at this central location only.

  Thanks to Brandon Goodin from the iBATIS team for the hint on how to make this work with Spring's integration strategy!

  See Also:
    `setTransactionConfigClass(java.lang.Class)`, `setTransactionConfigProperties(java.util.Properties)`, `SqlMapTransactionManager.getDataSource()`, `JdbcAccessor.setDataSource(javax.sql.DataSource)`

### setUseTransactionAwareDataSource

    public void setUseTransactionAwareDataSource(boolean useTransactionAwareDataSource)

  Set whether to use a transaction-aware DataSource for the SqlMapClient, i.e. whether to automatically wrap the passed-in DataSource with Spring's TransactionAwareDataSourceProxy.

  Default is "true": When the SqlMapClient performs direct database operations outside of Spring's SqlMapClientTemplate (for example, lazy loading or direct SqlMapClient access), it will still participate in active Spring-managed transactions.

  As a further effect, using a transaction-aware DataSource will apply remaining transaction timeouts to all created JDBC Statements. This means that all operations performed by the SqlMapClient will automatically participate in Spring-managed transaction timeouts.

  Turn this flag off to get raw DataSource handling, without Spring transaction checks. Operations on Spring's SqlMapClientTemplate will still detect Spring-managed transactions, but lazy loading or direct SqlMapClient access won't.

  See Also:
    `setDataSource(javax.sql.DataSource)`, `TransactionAwareDataSourceProxy`, `DataSourceTransactionManager`, `SqlMapClientTemplate`, `SqlMapClient`

### setTransactionConfigClass

    public void setTransactionConfigClass(java.lang.Class transactionConfigClass)

  Set the iBATIS TransactionConfig class to use. Default is `com.ibatis.sqlmap.engine.transaction.external.ExternalTransactionConfig`.

  Will only get applied when using a Spring-managed DataSource. An instance of this class will get populated with the given DataSource and initialized with the given properties.

  The default ExternalTransactionConfig is appropriate if there is external transaction management that the SqlMapClient should participate in: be it Spring transaction management, EJB CMT or plain JTA. This should be the typical scenario. If there is no active transaction, SqlMapClient operations will execute SQL statements non-transactionally.

  JdbcTransactionConfig or JtaTransactionConfig is only necessary when using the iBATIS SqlMapTransactionManager API instead of external transactions. If there is no explicit transaction, SqlMapClient operations will automatically start a transaction for their own scope (in contrast to the external transaction mode, see above).

  It is strongly recommended to use iBATIS SQL Maps with Spring transaction management (or EJB CMT). In this case, the default ExternalTransactionConfig is fine. Lazy loading and SQL Maps operations without explicit transaction demarcation will execute non-transactionally.

  Even with Spring transaction management, it might be desirable to specify JdbcTransactionConfig: This will still participate in existing Spring-managed transactions, but lazy loading and operations without explicit transaction demaration will execute in their own auto-started transactions. However, this is usually not necessary.

  See Also:
    `setDataSource(javax.sql.DataSource)`, `setTransactionConfigProperties(java.util.Properties)`, `TransactionConfig`, `ExternalTransactionConfig`, `com.ibatis.sqlmap.engine.transaction.jdbc.JdbcTransactionConfig`, `com.ibatis.sqlmap.engine.transaction.jta.JtaTransactionConfig`, `SqlMapTransactionManager`

### setTransactionConfigProperties

    public void setTransactionConfigProperties(java.util.Properties transactionConfigProperties)

  Set properties to be passed to the TransactionConfig instance used by this SqlMapClient. Supported properties depend on the concrete TransactionConfig implementation used:

  - ExternalTransactionConfig supports "DefaultAutoCommit" (default: false) and "SetAutoCommitAllowed" (default: true). Note that Spring uses SetAutoCommitAllowed = false as default, in contrast to the iBATIS default, to always keep the original autoCommit value as provided by the connection pool.
  - JdbcTransactionConfig does not supported any properties.
  - JtaTransactionConfig supports "UserTransaction" (no default), specifying the JNDI location of the JTA UserTransaction (usually "java:comp/UserTransaction").

  See Also:
    `TransactionConfig.initialize(java.util.Properties)`, `ExternalTransactionConfig`, `com.ibatis.sqlmap.engine.transaction.jdbc.JdbcTransactionConfig`, `com.ibatis.sqlmap.engine.transaction.jta.JtaTransactionConfig`

### setLobHandler

    public void setLobHandler(LobHandler lobHandler)

  Set the LobHandler to be used by the SqlMapClient. Will be exposed at config time for TypeHandler implementations.

  See Also:
    `getConfigTimeLobHandler()`, `TypeHandler`, `ClobStringTypeHandler`, `BlobByteArrayTypeHandler`, `BlobSerializableTypeHandler`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws java.lang.Exception

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `java.lang.Exception` - in the event of misconfiguration (such as failure to set an essential property) or if initialization fails.

### buildSqlMapClient

    protected com.ibatis.sqlmap.client.SqlMapClient buildSqlMapClient(Resource[] configLocations,
                                                                      Resource[] mappingLocations,
                                                                      java.util.Properties properties)
                                                               throws java.io.IOException

  Build a SqlMapClient instance based on the given standard configuration.

  The default implementation uses the standard iBATIS `SqlMapClientBuilder` API to build a SqlMapClient instance based on an InputStream (if possible, on iBATIS 2.3 and higher) or on a Reader (on iBATIS up to version 2.2).

  Parameters:
    `configLocations` - the config files to load from
    `properties` - the SqlMapClient properties (if any)
  Returns:
    the SqlMapClient instance (never `null`)
  Throws:
    `java.io.IOException` - if loading the config file failed
  See Also:
    `SqlMapClientBuilder.buildSqlMapClient(java.io.Reader)`

### applyTransactionConfig

    protected void applyTransactionConfig(com.ibatis.sqlmap.client.SqlMapClient sqlMapClient,
                                          com.ibatis.sqlmap.engine.transaction.TransactionConfig transactionConfig)

  Apply the given iBATIS TransactionConfig to the SqlMapClient.

  The default implementation casts to ExtendedSqlMapClient, retrieves the maximum number of concurrent transactions from the SqlMapExecutorDelegate, and sets an iBATIS TransactionManager with the given TransactionConfig.

  Parameters:
    `sqlMapClient` - the SqlMapClient to apply the TransactionConfig to
    `transactionConfig` - the iBATIS TransactionConfig to apply
  See Also:
    `ExtendedSqlMapClient`, `SqlMapExecutorDelegate.getMaxTransactions()`, `SqlMapExecutorDelegate.setTxManager(com.ibatis.sqlmap.engine.transaction.TransactionManager)`

### getObject

    public com.ibatis.sqlmap.client.SqlMapClient getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<com.ibatis.sqlmap.client.SqlMapClient>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<? extends com.ibatis.sqlmap.client.SqlMapClient> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<com.ibatis.sqlmap.client.SqlMapClient>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<com.ibatis.sqlmap.client.SqlMapClient>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD